package com.malk.zhixingtongde.entity;

import cn.hutool.core.util.NumberUtil;
import lombok.Data;

import java.math.RoundingMode;

@Data
public class Accounts {

    /**
     * 客户名称
     */
    private String customerName;

    /**
     * 期初余额
     */
    private String initialAmt;

    /**
     * 1月金额
     */
    private String amt1;

    /**
     * 2月金额
     */
    private String amt2;

    /**
     * 3月金额
     */
    private String amt3;

    /**
     * 4月金额
     */
    private String amt4;

    /**
     * 5月金额
     */
    private String amt5;

    /**
     * 6月金额
     */
    private String amt6;

    /**
     * 7月金额
     */
    private String amt7;

    /**
     * 8月金额
     */
    private String amt8;

    /**
     * 9月金额
     */
    private String amt9;

    /**
     * 10月金额
     */
    private String amt10;

    /**
     * 11月金额
     */
    private String amt11;

    /**
     * 12月金额
     */
    private String amt12;

    public Accounts() {

    }

    public Accounts(String customerName, String initialAmt, String amt1, String amt2, String amt3, String amt4, String amt5, String amt6, String amt7, String amt8, String amt9, String amt10, String amt11, String amt12) {
        this.customerName = customerName;
        this.initialAmt = initialAmt;
        this.amt1 = amt1;
        this.amt2 = amt2;
        this.amt3 = amt3;
        this.amt4 = amt4;
        this.amt5 = amt5;
        this.amt6 = amt6;
        this.amt7 = amt7;
        this.amt8 = amt8;
        this.amt9 = amt9;
        this.amt10 = amt10;
        this.amt11 = amt11;
        this.amt12 = amt12;
    }

    public Accounts(String initialAmt) {
        this.initialAmt = initialAmt;
    }

    public Accounts add(Accounts subTotalAccounts) {
        this.initialAmt = NumberUtil.add(this.initialAmt, subTotalAccounts.getInitialAmt()).toString();
        this.amt1 = NumberUtil.add(this.amt1, subTotalAccounts.getAmt1()).setScale(2, RoundingMode.HALF_UP).toString();
        this.amt2 = NumberUtil.add(this.amt2, subTotalAccounts.getAmt2()).setScale(2, RoundingMode.HALF_UP).toString();
        this.amt3 = NumberUtil.add(this.amt3, subTotalAccounts.getAmt3()).setScale(2, RoundingMode.HALF_UP).toString();
        this.amt4 = NumberUtil.add(this.amt4, subTotalAccounts.getAmt4()).setScale(2, RoundingMode.HALF_UP).toString();
        this.amt5 = NumberUtil.add(this.amt5, subTotalAccounts.getAmt5()).setScale(2, RoundingMode.HALF_UP).toString();
        this.amt6 = NumberUtil.add(this.amt6, subTotalAccounts.getAmt6()).setScale(2, RoundingMode.HALF_UP).toString();
        this.amt7 = NumberUtil.add(this.amt7, subTotalAccounts.getAmt7()).setScale(2, RoundingMode.HALF_UP).toString();
        this.amt8 = NumberUtil.add(this.amt8, subTotalAccounts.getAmt8()).setScale(2, RoundingMode.HALF_UP).toString();
        this.amt9 = NumberUtil.add(this.amt9, subTotalAccounts.getAmt9()).setScale(2, RoundingMode.HALF_UP).toString();
        this.amt10 = NumberUtil.add(this.amt10, subTotalAccounts.getAmt10()).setScale(2, RoundingMode.HALF_UP).toString();
        this.amt11 = NumberUtil.add(this.amt11, subTotalAccounts.getAmt11()).setScale(2, RoundingMode.HALF_UP).toString();
        this.amt12 = NumberUtil.add(this.amt12, subTotalAccounts.getAmt12()).setScale(2, RoundingMode.HALF_UP).toString();
        return this;
    }

    public Accounts sub(Accounts subTotalAccounts) {
        this.initialAmt = NumberUtil.sub(this.initialAmt, subTotalAccounts.getInitialAmt()).toString();
        this.amt1 = NumberUtil.sub(this.amt1, subTotalAccounts.getAmt1()).setScale(2, RoundingMode.HALF_UP).toString();
        this.amt2 = NumberUtil.sub(this.amt2, subTotalAccounts.getAmt2()).setScale(2, RoundingMode.HALF_UP).toString();
        this.amt3 = NumberUtil.sub(this.amt3, subTotalAccounts.getAmt3()).setScale(2, RoundingMode.HALF_UP).toString();
        this.amt4 = NumberUtil.sub(this.amt4, subTotalAccounts.getAmt4()).setScale(2, RoundingMode.HALF_UP).toString();
        this.amt5 = NumberUtil.sub(this.amt5, subTotalAccounts.getAmt5()).setScale(2, RoundingMode.HALF_UP).toString();
        this.amt6 = NumberUtil.sub(this.amt6, subTotalAccounts.getAmt6()).setScale(2, RoundingMode.HALF_UP).toString();
        this.amt7 = NumberUtil.sub(this.amt7, subTotalAccounts.getAmt7()).setScale(2, RoundingMode.HALF_UP).toString();
        this.amt8 = NumberUtil.sub(this.amt8, subTotalAccounts.getAmt8()).setScale(2, RoundingMode.HALF_UP).toString();
        this.amt9 = NumberUtil.sub(this.amt9, subTotalAccounts.getAmt9()).setScale(2, RoundingMode.HALF_UP).toString();
        this.amt10 = NumberUtil.sub(this.amt10, subTotalAccounts.getAmt10()).setScale(2, RoundingMode.HALF_UP).toString();
        this.amt11 = NumberUtil.sub(this.amt11, subTotalAccounts.getAmt11()).setScale(2, RoundingMode.HALF_UP).toString();
        this.amt12 = NumberUtil.sub(this.amt12, subTotalAccounts.getAmt12()).setScale(2, RoundingMode.HALF_UP).toString();
        return this;
    }


}
